namespace IRDB_SDK
{

	using namespace std;

	class DatabaseError_t : virtual public exception 
	{
		protected:
		public: 
			enum DatabaseErrorType_t {VariantNotInDatabase, VariantTableNotRegistered};
	};

	ostream& operator<<(ostream& output, const DatabaseError_t& p);


	// an interface to a database
	class DBinterface_t
	{
		protected:
			DBinterface_t() {}
			DBinterface_t(const DBinterface_t& copy) = delete;
		public:
			virtual ~DBinterface_t() {};

			virtual void   issueQuery(string query)        = 0;
			virtual void   moveToNextRow()                 = 0;
			virtual string getResultColumn(string colname) = 0;
			virtual bool   isDone()                        = 0;
			virtual void   commit()                        = 0;

	};

}
