namespace IRDB_SDK
{

	using namespace std;

	class EhProgram_t : virtual public BaseObj_t
	{
		protected:
			EhProgram_t() { }
			EhProgram_t(const EhProgram_t& copy) = delete;
		public:

			virtual ~EhProgram_t() { }
			virtual const EhProgramListing_t& getCIEProgram()          const = 0;
			virtual const EhProgramListing_t& getFDEProgram()          const = 0;
			virtual uint64_t                  getCodeAlignmentFactor() const = 0;
			virtual int64_t                   getDataAlignmentFactor() const = 0;
			virtual int64_t                   getReturnRegNumber()     const = 0;
			virtual uint8_t                   getPointerSize()         const = 0;

			virtual void setCodeAlignmentFactor(const uint64_t caf) = 0;
			virtual void setDataAlignmentFactor(const int64_t daf)  = 0;
			virtual void setReturnRegNumber    (const uint8_t rr  ) = 0;
			virtual void setCIEProgram(const EhProgramListing_t& p) = 0;
			virtual void setFDEProgram(const EhProgramListing_t& p) = 0;

			// helpers
			virtual void print() const = 0;
	};

	class EhCallSite_t : virtual public BaseObj_t
	{
		protected:
			EhCallSite_t() { } ;
			EhCallSite_t(const EhCallSite_t& copy)=delete;
		public:

			virtual ~EhCallSite_t() { } ;
			virtual uint64_t               getTTEncoding()    const = 0;
			virtual const TTOrderVector_t& getTTOrderVector() const = 0;
			virtual Instruction_t*         getLandingPad()    const = 0;
			virtual bool                   getHasCleanup()    const = 0;

			virtual void setTTEncoding(const uint64_t p_tt)     = 0;
			virtual void setLandingPad(Instruction_t* lp)       = 0;
			virtual void setHasCleanup(bool p_has_cleanup=true) = 0;
			virtual void setTTOrderVector(const TTOrderVector_t& ) = 0;

	};

}
