

namespace IRDB_SDK
{

	using namespace std;

	class Function_t : virtual public BaseObj_t
	{
		protected:
			Function_t() {}
			Function_t(const Function_t&copy) = delete;

		public:
			// getters
			virtual const InstructionSet_t& getInstructions()      const = 0;
			virtual const int               getStackFrameSize()    const = 0;
			virtual const string&           getName()              const = 0;
			virtual uint32_t                getOutArgsRegionSize() const = 0;
			virtual Instruction_t*          getEntryPoint()        const = 0;
			virtual bool                    getUseFramePointer()   const = 0;
			virtual int                     getNumArguments()      const = 0;
			virtual FuncType_t*             getType()              const = 0;
			virtual bool                    isSafe()               const = 0;

			// muttators
			virtual void setStackFrameSize(int size)            = 0;
			virtual void setName(string newname)	            = 0;
			virtual void setOutArgsRegionSize(uint32_t oa_size) = 0;
			virtual void setEntryPoint(Instruction_t *insn)     = 0;
			virtual void setUseFramePointer(bool useFP)         = 0;
			virtual void setSafe(bool safe)                     = 0;
			virtual void setType(FuncType_t *t)                 = 0;
	};

}
