namespace IRDB_SDK
{
	using namespace std;

	class DataScoop_t : virtual public BaseObj_t
	{

		protected:
			DataScoop_t() {}
			DataScoop_t(const DataScoop_t& copy) = delete;
		public:
			virtual ~DataScoop_t() { }

			virtual const string     getName()       const = 0;
			virtual const string&    getContents()   const = 0;
			virtual AddressID_t*     getStart()      const = 0;
			virtual AddressID_t*     getEnd()        const = 0;
			virtual Type_t*          getType()       const = 0;
			virtual VirtualOffset_t  getSize()       const = 0;
			virtual bool             isReadable()    const = 0;
			virtual bool             isWriteable()   const = 0;
			virtual bool             isExecuteable() const = 0;
			virtual bool             isRelRo()       const = 0;
			virtual uint8_t          getRawPerms()   const = 0;

			virtual void setName(const string &n)     = 0;
			virtual void setContents(const string &n) = 0;
			virtual void setStart( AddressID_t* addr) = 0;
			virtual void setEnd( AddressID_t* addr )  = 0;
			virtual void setType( Type_t*  t)         = 0;
			virtual void setReadable()                = 0;
			virtual void setWriteable()               = 0;
			virtual void setExecuteable()             = 0;
			virtual void setRelRo()                   = 0;
			virtual void clearReadable()              = 0;
			virtual void clearWriteable()             = 0;
			virtual void clearExecuteable()           = 0;
			virtual void clearRelRo()                 = 0;
			virtual void setRawPerms(int newperms)    = 0;

	};
}
